<?php

/*
Plugin Name: PixFuture Ad Solution
Plugin URI:  http://pixfuture.com/plugins/pixfuture-solution/
Description: Ad performans solution
Version:     1.0
Author:      PixFuture Dev Team
Author URI:  http://pixfuture.com
License:     GPL2
*/

function encryptData($plainData){
    $encodedData = array();
   
    foreach ($plainData as $keyD => $dat) {
        if($dat != ""){
            $encodedData[$keyD] = array(
                "md5" => md5($dat),
                "sha1" => sha1($dat),
                "sha256" => hash('sha256',$dat),
                "plain" => $keyD == "gender" || $keyD == "age" ? $dat : ''
            );
        
            // Get the public Key of the recipient
            $publicKey = openssl_pkey_get_public("-----BEGIN PUBLIC KEY-----".PHP_EOL.
            "MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA5l7Pxw41x7Ih4g14zx1K".PHP_EOL.
            "PngBa71ttO2EI1VX1ga/luupH4HowjCbUp1t45AcS2HNVLEWNlGPvqv8BDfTnPW4".PHP_EOL.
            "ogq2D3qkrlqRRpUXiq2maPpR9OJSnP+U+UMxvUN57d6Vsvldwm8iqV8kouuBBt9C".PHP_EOL.
            "uJ95eGKwR1JIeBAG02P7t19Ip6cQex/u7zZ7sBP25PYsALlq2aRp0cZY086b4B1i".PHP_EOL.
            "uuoFSHuJ1VVTZ80ayRMKx+hTtjavgub9grr257h7gTxftbfG+Fl0Jjg0swGrQIof".PHP_EOL.
            "fWduv21vw1NyAXY649Ht1+Rkf7J2eHThQhbyuoTXeEAIZ22yJVSH9FfAR4U8VCiY".PHP_EOL.
            "4wIDAQAB".PHP_EOL.
            "-----END PUBLIC KEY-----".PHP_EOL.
            "");
            $a_key = openssl_pkey_get_details($publicKey);
            // Compress the data to be sent
            $plaintext = gzcompress($dat);
        
            // Encrypt the data in small chunks and then combine and send it.
            $chunkSize = ceil($a_key['bits'] / 8) - 11;
            $output = '';
            while ($plaintext)
            {
                $chunk = substr($plaintext, 0, $chunkSize);
                $plaintext = substr($plaintext, $chunkSize);
                $encrypted = '';

                if (!openssl_public_encrypt($chunk, $encrypted, $publicKey))
                {
                    die('Failed to encrypt data');
                }

                $output .= $encrypted;
            }
            openssl_free_key($publicKey);
            // This is the final encrypted data to be sent to the recipient
            $encodedData[$keyD]["openssl"] = rawurlencode($output);
        }
    }
    return $encodedData;
}

function get_user_data_pixfuture() {
	$userDataWP = _wp_get_current_user();

// Data to be sent
$email = $userDataWP->__isset( 'user_email' ) ? $userDataWP->get("user_email") :  '';
$phone = function_exists('um_user') && um_user('phone_number') ? um_user('phone_number') :  '';
$gender = function_exists('um_user') && um_user('gender') ? um_user('gender')[0] :  '';
$age = function_exists('um_user') && um_user('birth_date') ? explode("/", um_user('birth_date'))[0] :  '';

$plainData = array(
    "email" => $email != '' ? $email : '',
    "phone" => $phone != '' ? $phone : '',
    "gender" => $gender != '' ? $gender : '',
    "age" => $age != '' ? $age : ''
   );

   $encryptedData = encryptData($plainData);
   $encryptedData["pixHashes"] = true;

$args = array ('encryptedData'=>$encryptedData);

add_action('wp_head', function() use ( $encryptedData ) {
    ?>
        <script>
            function handlePixMessage (e) {
            // Reference to element for data display
            let regexServed = /served-by.pixfuture.com/g;
            let regexDFP = /.googlesyndication.com/g;

            if ( e.origin.match(regexServed) != null || e.origin.match(regexDFP) != null) {
            e.source.postMessage(' <?php echo json_encode($encryptedData); ?> ', e.origin);
            }
            }
            window.addEventListener("message", handlePixMessage, false);
            var _pixHashes = '<?php echo json_encode($encryptedData); ?>';
        </script>
    <?php
},-1000);
   //sendData($encryptedData);
}

add_action('init','get_user_data_pixfuture');
